<script lang="ts">
import Vue from "vue";

import {
  SlpButton,
  SlpColumn,
  SlpContainer,
  SlpRow,
  SlpTypography,
} from "slippers-ui";

import CloseIcon from "../../assets/close.vue";
import SlpSearchContent from "../Search/search-content.vue";
import { SEARCH_TYPE } from "../../services/search.service";

/**
 * Primary component for the search, it contains the search content, the search results and the search suggestions
 */
export default Vue.extend({
  name: "SlpSearch",
  components: {
    SlpSearchContent,
    SlpRow,
    SlpColumn,
    SlpContainer,
    SlpButton,
    SlpTypography,
    CloseIcon,
  },
  props: {
    data: {
      required: false,
      type: Object,
    },
  },
  data() {
    return {
      searchResults: null,
      searchText: "",
      searchFilter: SEARCH_TYPE.MARKETING,
    };
  },
  methods: {
    close() {
      this.$emit("close");
    },
    /**
     * Search service implementation, it will be called when the user submit the search or change the page in the pagination
     * @param searchText
     */
    onSearch(searchText: string) {
      const searchEvent = new CustomEvent("navSearch", {
        detail: { searchText },
      });
      document.dispatchEvent(searchEvent);
      this.close();
    },
    cleanSearchResults() {
      this.searchResults = null;
    },
  },
});
</script>

<template>
  <section class="be-nav-search">
    <SlpContainer class="be-nav-search__container">
      <SlpRow class="be-nav-search__row">
        <SlpColumn :cols="3" class="be-nav-search__right" />
        <SlpColumn :cols="9">
          <template v-if="!searchResults">
            <div class="be-nav-search__close">
              <SlpButton variant="ghost" @click.native="close()">
                <SlpTypography
                  variant="body3"
                  class="be-nav-search__close--text"
                >
                  Close</SlpTypography
                >
                <CloseIcon class="slp-ml-8" fill="#171321" />
              </SlpButton>
            </div>
            <SlpSearchContent @search="onSearch" />
          </template>
        </SlpColumn>
      </SlpRow>
    </SlpContainer>
  </section>
</template>

<style lang="scss">
.be-nav-search {
  position: fixed;
  top: 84px;
  right: 0;
  bottom: 0;
  left: 0;
  background-color: $color-surface-50;
  overflow-y: scroll;

  @media (max-width: $breakpoint-lg) {
    top: 0;
    overflow-x: hidden;
  }

  &__container {
    height: 100%;

    @media (max-width: $breakpoint-lg) {
      padding: 0 !important;
    }
  }

  &__row {
    height: 100%;

    &:focus-visible {
      outline: none;
    }
  }

  &__right {
    @media (max-width: $breakpoint-md) {
      display: none;
    }

    &:before {
      content: "";
      position: absolute;
      background-color: $color-surface-700;
      top: 0;
      left: -50vw;
      right: 0;
      bottom: 0;
      z-index: -1;

      @media (max-width: $breakpoint-md) {
        background-color: white !important;
      }
    }
  }

  &__close {
    display: flex;
    justify-content: flex-end;
    margin-top: $spacing-16;

    &--text {
      color: $color-text-300 !important;
    }
  }
}
</style>
